import net.java.games.jogl.*;
import java.awt.event.*;
import java.lang.Math;

//built on J1_O_Point class
public class H1_1_Moving
    extends J1_0_Point {

  double c_x;
  double c_y;
  double radiou;
  double theta;

  static Animator animator; // drive display() in a loop

  public H1_1_Moving() {

    c_x = WIDTH / 2;
    c_y = HEIGHT / 2;
    theta =0;
    radiou = 100;

    //1. use super's constructor to initialize drawing
    // super(); this will be called by default -ddu comments
    //2. add a listener for window closing
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        animator.stop(); // stop animation
        System.exit(0);
      }
    });
  }

  // Called one-time for OpenGL initialization
  public void init(GLDrawable drawable) {

    GL gl = drawable.getGL();
    //3. clear the background to black
    gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    gl.glClear(GL.GL_COLOR_BUFFER_BIT);
    // specify a drawing color: red
    gl.glColor3f(1.0f, 0.0f, 0.0f);
    gl.glPointSize (3.0f);
    //4. drive the display() in a loop
    animator = new Animator(canvas);
    animator.start(); // start animator thread

  }

  // Called for OpenGL rendering every reshape
  public void display(GLDrawable drawable) {

    GL gl = drawable.getGL();
    gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    gl.glClear(GL.GL_COLOR_BUFFER_BIT);

    //draw circle
    drawCircle(gl);

    double x = radiou * Math.cos(theta) + c_x;
    double y = radiou * Math.sin(theta) + c_y;
    //draw a point on Circle
    drawPointOnCircle(gl, (int)x, (int)y);
    theta = theta + (2 * Math.PI) / 3600;
    if( theta >= 2 * Math.PI)
      theta =0;
  }

  public void drawCircle(GL gl) {

    gl.glBegin(GL.GL_POINTS);
    gl.glColor3f(1.0f, 0.0f, 0.0f);

    double th=0;
    while (th <= 2 * Math.PI) {
      double x = radiou * Math.cos(th) + c_x;
      double y = radiou * Math.sin(th) + c_y;
      gl.glVertex2d(x, y);
      th = th + (2 * Math.PI) / 360;
    }
    gl.glEnd();
  }

  public void drawPointOnCircle(GL gl, int x, int y) {

      gl.glBegin(GL.GL_POINTS);
      gl.glColor3f(0.0f, 1.0f, 0.0f);
      gl.glVertex2d(x, y);
      gl.glEnd();
    }


  public void reshape(
      GLDrawable drawable,
      int x,
      int y,
      int width,
      int height) {
    //added by ddu, otherwise
    //clear the background to black
    GL gl = drawable.getGL();

    gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    gl.glClear(GL.GL_COLOR_BUFFER_BIT);

    //7. specify the drawing area (frame) coordinates
    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glLoadIdentity();
    gl.glOrtho(0, width, 0, height, -1.0, 1.0);
    c_x = width / 2;
    c_y = height / 2;
  }

  public static void main(String[] args) {
    H1_1_Moving f = new H1_1_Moving();

    //modified by ddu to show this example title
    f.setTitle("CS451 HW1");
    f.setSize(WIDTH, HEIGHT);
    f.setVisible(true);

  }
}
